
#include <LcdBarGraphX.h>


#include <Wire.h> 
#include <LiquidCrystal_I2C.h>

byte lcdNumCols = 20; // -- number of columns in the LCD

LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);   // -- creating LCD instance

// -- creating a 4 chars wide bars
LcdBarGraphX lbg0(&lcd, 16, 0, 1); // -- First line at column 0
LcdBarGraphX lbg1(&lcd, 4, 5, 0); // -- First line at column 5
LcdBarGraphX lbg2(&lcd, 4, 10, 0); // -- First line at column 10
LcdBarGraphX lbg3(&lcd, 4, 0, 1); // -- Second line at column 0
LcdBarGraphX lbg4(&lcd, 4, 5, 1);  // -- Second line at column 5
LcdBarGraphX lbg5(&lcd, 4, 10, 1); // -- Second line at column 0

byte i0 = 0;
byte i1 = 0;
byte i2 = 0;
byte i3 = 0;
byte i4 = 0;
byte i5 = 0;


const int echoPin = 4;

void setup() {
 
  // -- initializing the LCD
  lcd.begin(4, lcdNumCols);
  lcd.clear();
  // -- do some delay: some time I've got broken visualization
  delay(100);
  Serial.begin(9600);
}

void loop()
{
  // establish variables for duration of the ping, 
  // and the distance result in inches and centimeters:
  long duration, inches, cm;

  // The sensor is triggered by a HIGH pulse of 10 or more microseconds.
  // Give a short LOW pulse beforehand to ensure a clean HIGH pulse:
  pinMode(A2, OUTPUT);
  digitalWrite(A2, LOW);
  delayMicroseconds(2);
  digitalWrite(A2, HIGH);
  delayMicroseconds(10);
  digitalWrite(A2, LOW);

  // Read the signal from the sensor: a HIGH pulse whose
  // duration is the time (in microseconds) from the sending
  // of the ping to the reception of its echo off of an object.
  pinMode(echoPin, INPUT);
  duration = pulseIn(echoPin, HIGH);

  // convert the time into a distance
  inches = microsecondsToInches(duration);
  cm = microsecondsToCentimeters(duration);


  
 
  lcd.setCursor(0,0);
  lcd.print(cm);
  lcd.print("cm            ");
  
  
  lbg0.drawValue( cm, 255);
  
  
  
  
  delay(50);
}

long microsecondsToInches(long microseconds)
{
  // According to Parallax's datasheet for the PING))), there are
  // 73.746 microseconds per inch (i.e. sound travels at 1130 feet per
  // second).  This gives the distance travelled by the ping, outbound
  // and return, so we divide by 2 to get the distance of the obstacle.
  // See: http://www.parallax.com/dl/docs/prod/acc/28015-PING-v1.3.pdf
  return microseconds / 74 / 2;
}

long microsecondsToCentimeters(long microseconds)
{
  // The speed of sound is 340 m/s or 29 microseconds per centimeter.
  // The ping travels out and back, so to find the distance of the
  // object we take half of the distance travelled.
  return microseconds / 29 / 2;
}
